// Copyright 2014 Renato Tegon Forti, Antony Polukhin.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt
// or copy at http://www.boost.org/LICENSE_1_0.txt)

#ifndef BOOST_APPLICATION_DETAIL_PROCESS_ID_HPP
#define BOOST_APPLICATION_DETAIL_PROCESS_ID_HPP

#include <boost/application/system_error.hpp>

#include <cstdlib>

#ifdef BOOST_HAS_PRAGMA_ONCE
# pragma once
#endif

namespace boost::application::detail {

   class  process_id_impl {

   public:
      typedef pid_t native_pid_t;
      
      process_id_impl()
         : pid_(0)
      {}

      explicit process_id_impl(native_pid_t pid)
         : pid_(pid)
      {}

      native_pid_t pid() noexcept {
         if(pid_)
            return pid_;

         pid_ = getpid();
         return pid_;
      }

   private:
      native_pid_t pid_;
   };

} // namespace boost::application::detail

#endif // BOOST_APPLICATION_DETAIL_PROCESS_ID_HPP
